<?php
/**
 * @version     1.0.1
 * @package     com_seopanel
 * @copyright   Copyright (C) 2011. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Created by Jennifer Grotheer - http://www.seo-panel.de
 */


// No direct access
defined('_JEXEC') or die;

class SeopanelController extends JController
{
	/**
	 * Method to display a view.
	 *
	 * @param	boolean			$cachable	If true, the view output will be cached
	 * @param	array			$urlparams	An array of safe url parameters and their variable types, for valid values see {@link JFilterInput::clean()}.
	 *
	 * @return	JController		This object to support chaining.
	 * @since	1.5
	 */
	public function display($cachable = false, $urlparams = false)
	{
		require_once JPATH_COMPONENT.'/helpers/seopanel.php';
		require_once JPATH_COMPONENT.'/helpers/seocharts.php';
  

		// Load the submenu.
		SeopanelHelper::addSubmenuHome(JRequest::getCmd('view', 'panel'));
		
		if (JRequest::getCmd( 'view' ) == "plugin")
		{
    SeopanelHelper::addSubmenuPlugin(JRequest::getCmd('view', 'plugin'));}
		else if (JRequest::getCmd( 'view' ) != "plugin" AND JRequest::getCmd( 'view' ) != "keywords" AND JRequest::getCmd( 'view' ) != "websites" )
    {
    SeopanelHelper::addSubmenuAnalyze(JRequest::getCmd('view', 'panel'));
    SeopanelHelper::addSubmenuSettings(JRequest::getCmd('view', 'panel')); 
    SeopanelHelper::addSubmenuPluginLink(JRequest::getCmd('view', 'panel'));
    }		
    else 
    {
    SeopanelHelper::addSubmenuSettings(JRequest::getCmd('view', 'keywords')); 
    }
    
		$view		= JRequest::getCmd('view', 'panel');
        JRequest::setVar('view', $view);

		parent::display();

		return $this;
	}
	
}
