<?php
/**
 * @version     1.0.1
 * @package     com_seopanel
 * @copyright   Copyright (C) 2011. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Created by Jennifer Grotheer - http://www.seo-panel.de
 */

// No direct access
defined('_JEXEC') or die;

/**
 * Seopanel helper.
 */
class SeopanelHelper
{
	/**
	 * Configure the Linkbar.
	 */

	public static function addSubmenuHome($vName = '')
	{
		JSubMenuHelper::addEntry(
			JText::_('COM_SEOPANEL_TITLE_PANEL'),
			'index.php?option=com_seopanel&view=panel',
			$vName == 'panel'
		);
}
	 
	 
	public static function addSubmenuSettings($vName = '')
	{


		JSubMenuHelper::addEntry(
			JText::_('COM_SEOPANEL_TITLE_WEBSITES'),
			'index.php?option=com_seopanel&view=websites',
			$vName == 'websites'
		);
		JSubMenuHelper::addEntry(
			JText::_('COM_SEOPANEL_TITLE_KEYWORDS'),
			'index.php?option=com_seopanel&view=keywords',
			$vName == 'keywords'
		);
	}
	public static function addSubmenuAnalyze($vName = '')
	{
		
				JSubMenuHelper::addEntry(
			JText::_('COM_SEOPANEL_TITLE_KEYRANKING'),
			'index.php?option=com_seopanel&view=keyranking',
			$vName == 'keyranking'
		);

				JSubMenuHelper::addEntry(
			JText::_('COM_SEOPANEL_TITLE_KEYDETAIL'),
			'index.php?option=com_seopanel&view=keydetail',
			$vName == 'keydetail'
		);

				JSubMenuHelper::addEntry(
			JText::_('COM_SEOPANEL_TITLE_RANKBERICHT'),
			'index.php?option=com_seopanel&view=pagerank',
			$vName == 'pagerank'
		);		
				JSubMenuHelper::addEntry(
			JText::_('COM_SEOPANEL_TITLE_BACKLINKS'),
			'index.php?option=com_seopanel&view=backlinks',
			$vName == 'backlinks'
		);
				JSubMenuHelper::addEntry(
			JText::_('COM_SEOPANEL_TITLE_SICHTBARKEIT'),
			'index.php?option=com_seopanel&view=visibility',
			$vName == 'visibility'
		);
		
}

	public static function addSubmenuPluginLink($vName = '')
	{


		JSubMenuHelper::addEntry(
			JText::_('COM_SEOPANEL_TITLE_PLUGINS'),
			'index.php?option=com_plugins&view=plugins&filter_folder=seopanel',
			$vName == 'websites'
		);
	}
	public static function addSubmenuPlugin($vName = '')
	{
	
	  $plugins = SeopanelHelper::getPluginsdata();
	  
	  
		foreach ( $plugins[0] as $plugin) {

	  	$lang 		= & JFactory::getLanguage();

      $extension = 'plg_seopanel_'.$plugin[0];
      $base_dir = JPATH_ADMINISTRATOR;

      $lang->load($extension, $base_dir, null, true);


		JSubMenuHelper::addEntry(
			JText::_('PLG_SEOPANEL_TITLE'),
			'index.php?option=com_seopanel&view=plugin&task='.$plugin[0],
			$vName == $plugin[0]
		);

   }
}
	/**
	 * Method to get plugins for seopanel
	 *
	 * @access public
	 * @return array
	 */
	public static function getPluginsdata()
	{
		$_plugins = array();
    $db = JFactory::getDbo();
		/*
		* Get plugins where published
		*/
		$query = 'SELECT element'
					. ' FROM #__extensions'
					. ' WHERE enabled=1 AND folder="seopanel"'
					;
 
 		$db->SetQuery($query);
  		$_plugins[] = $db->loadRowList();


		return $_plugins;
	}

	/**
	 * Gets a list of the actions that can be performed.
	 *
	 * @return	JObject
	 * @since	1.6
	 */
	public static function getActions()
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		$assetName = 'com_seopanel';

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.own', 'core.edit.state', 'core.delete'
			
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}
	
	public static function getWebSite($id='',$row ='')
	{
		$db = JFactory::getDbo();
		
		$db->setQuery(
			'SELECT id AS value, domain AS website' .
			' FROM #__seopanel_websites WHERE state=1'
		);		
		if ($id) {
    $db->setQuery(
			'SELECT id AS value, domain AS website' .
			' FROM #__seopanel_websites WHERE state=1 AND id='.$id
		);
    
    
    }
		/*
    'SELECT id,domain from `#__seopanel_domain`'
    */
		$options = $db->loadObjectList();

		// Check for a database error.
		if ($db->getErrorNum()) {
			JError::raiseNotice(500, $db->getErrorMsg());
			return null;
		}


		return $options;
	}
	
	
	public static function getSearchEngines($id='')
	{
		$db = JFactory::getDbo();
		
		$db->setQuery(
			'SELECT id AS value, domain AS domain' .
			' FROM #__seopanel_searchengines'
		);		
		if ($id) {
    $db->setQuery(
			'SELECT id AS value, domain AS domain' .
			' FROM #__seopanel_searchengines WHERE id='.$id
		);
    
    
    }
		/*
    'SELECT id,domain from `#__seopanel_domain`'
    */
		$options = $db->loadObjectList();

		// Check for a database error.
		if ($db->getErrorNum()) {
			JError::raiseNotice(500, $db->getErrorMsg());
			return null;
		}


		return $options;
	}	
	
	
	public static function getCountryCode()
	{
		$db = JFactory::getDbo();
		
		$db->setQuery(
			'SELECT country_code AS value, country_name AS name' .
			' FROM #__seopanel_country WHERE 1'
		);		

		/*
    'SELECT id,domain from `#__seopanel_domain`'
    */
		$options = $db->loadObjectList();

		// Check for a database error.
		if ($db->getErrorNum()) {
			JError::raiseNotice(500, $db->getErrorMsg());
			return null;
		}


		return $options;
	}

	public static function getLangCode()
	{
		$db = JFactory::getDbo();
		
		$db->setQuery(
			'SELECT lang_code AS value, lang_name AS name' .
			' FROM #__seopanel_languages'
		);		

		/*
    'SELECT id,domain from `#__seopanel_domain`'
    */
		$options = $db->loadObjectList();

		// Check for a database error.
		if ($db->getErrorNum()) {
			JError::raiseNotice(500, $db->getErrorMsg());
			return null;
		}


		return $options;
	}


	public static function getKewords($w_id='',$row ='')
	{
		$db = JFactory::getDbo();
		
		$db->setQuery(
			'SELECT id AS value, name AS name' .
			' FROM #__seopanel_keywords WHERE state=1'
		);		
		if ($w_id && !$row) {
    $db->setQuery(
			'SELECT id AS value, name AS name' .
			' FROM #__seopanel_keywords WHERE state=1 AND website_id='.$w_id 
			
		);
		}
    if ($row) {
    $db->setQuery(
			'SELECT id,name,state' .
			' FROM #__seopanel_keywords WHERE website_id='.$w_id 
			
		);
    
    }
		/*
    'SELECT id,domain from `#__seopanel_domain`'
    */
		    
    if ($row == true) {
    $options = $db->loadAssocList(); 
    } else {
		$options = $db->loadObjectList();    
    }

		// Check for a database error.
		if ($db->getErrorNum()) {
			JError::raiseNotice(500, $db->getErrorMsg());
			return null;
		}

		return $options;
	}


	public static function getDateSelect($limit = 14)
	{
		$db = JFactory::getDbo();
		
		$db->setQuery(
			"SELECT time AS value, FROM_UNIXTIME(time,'%d.%m.%Y') AS date" .
			" FROM #__seopanel_searchresults WHERE 1 GROUP by time ORDER by time DESC LIMIT ".$limit

		);		

		$options = $db->loadObjectList();

		// Check for a database error.
		if ($db->getErrorNum()) {
			JError::raiseNotice(500, $db->getErrorMsg());
			return null;
		}

		return $options;
	}


	public static function getKewordRank($keyID='1',$SearchID='1', $time='', $SrId='', $SUrl='', $ARank='',$StatImg='0',$SiteId='')
	{
		$db = JFactory::getDbo();

    if($time) $wheretime = "AND time <= ".$time;

		$db->setQuery(
			'SELECT min( rank ) AS rank' . 
      ' FROM #__seopanel_searchresults WHERE keyword_id ='.$keyID.
      ' AND searchengine_id ='.$SearchID.' '.$wheretime.' GROUP BY time ORDER BY time DESC' .
      ' LIMIT 0 , 2 ' 
     );


  if ($SrId) {
  
		$db->setQuery(
        "SELECT ssd.*, srs.* FROM #__seopanel_searchresultdetails AS ssd, #__seopanel_searchresults AS srs " .
        " WHERE ssd.searchresult_id < ".$SrId ." AND srs.searchengine_id = ".$SearchID.
        " AND url LIKE '".$SUrl."' AND ssd.searchresult_id = srs.id ". "AND srs.keyword_id=".$keyID.
        " ORDER by time DESC LIMIT 0 , 1 " 
     );  
  }


		$keyranking = $db->loadRowList();

  if ($SrId) {
          $keyranking[1][0] = $keyranking[0][7];
          $keyranking[0][0] = $ARank;
    }
    
    
		// Check for a database error.
		if ($db->getErrorNum()) {
			JError::raiseNotice(500, $db->getErrorMsg());
			return null;
		}

			  
          $rankDiff = '';
					$rankDiff = $keyranking[1][0] - $keyranking[0][0];
          
         // echo "(".$rankDiff." - ".$keyranking[0][0]." - ".$keyranking[1][0].")";
          
          if ($rankDiff !=0){
					if ($rankDiff > 0) {
						$rankDiff = "<font class='green'>(+$rankDiff)</font>";
					}elseif ($rankDiff < 0) {
						$rankDiff = "<font class='red'>($rankDiff)</font>";
					}

        } else {$rankDiff = '';}
          $date = mktime(0, 0, 0, date('m'), date('d'), date('Y'));
					if ($StatImg == 1) $rankDiff = '<a href="index.php?option=com_seopanel&view=keydetail&filter_keyword='.$keyID.'&filter_website='.$SiteId.'&filter_searchdate='.$date.'" class="graphicon">&nbsp;</a>'.$rankDiff;

        if($time) {
        $keyranking = $rankDiff;
        } else {
        $keyranking = empty ($keyranking[0][0]) ? '-' : '<div class="keywordranking">'.$keyranking[0][0].'</div> '.$rankDiff;
        }

		return $keyranking;
	}



	public static function getRangMinMax($keyID='1',$SearchID='1', $sort = 'ASC')
	{
		$db = JFactory::getDbo();

    if ($keyID == '') $keyID=0;

		$db->setQuery(
			'SELECT rank AS ranking, FROM_UNIXTIME(time,\'%d.%m.%y\') AS date' . 
      ' FROM #__seopanel_searchresults WHERE keyword_id ='.$keyID.
      ' AND searchengine_id ='.$SearchID .' ORDER by rank ' .$sort.
      ' LIMIT 0 , 1 ' 
     );
    

		$keyranking = $db->loadRowList();

		// Check for a database error.
		if ($db->getErrorNum()) {
			JError::raiseNotice(500, $db->getErrorMsg());
			return null;
		}
  
		return $keyranking;
	}


	public static function getBacklinks($SiteID='1', $time='',$table='google')
	{
		$db = JFactory::getDbo();


    if($time) $wheretime = "AND result_time <= ".$time; else $wheretime = "AND result_time < ".time();

		$db->setQuery(
			'SELECT '.$table.'' . 
      ' FROM #__seopanel_backlinkresults WHERE website_id ='.$SiteID.
      ' '.$wheretime.'  ORDER BY result_time DESC' .
      ' LIMIT 0 , 2 ' 
     );

		$_backlinks = $db->loadRowList();

   
		// Check for a database error.
		if ($db->getErrorNum()) {
			JError::raiseNotice(500, $db->getErrorMsg());
			return null;
		}

			  
          $rankDiff = '';
					$rankDiff = $_backlinks[0][0] - $_backlinks[1][0];
          
          
          if ($rankDiff !=0){
					if ($rankDiff > 0) {
						$rankDiff = "<font class='green'>(+$rankDiff)</font>";
					}elseif ($rankDiff < 0) {
						$rankDiff = "<font class='red'>($rankDiff)</font>";
					}
        } else {$rankDiff = '';}


        $_backlinks = empty ($_backlinks[0][0]) ? '0' : $_backlinks[0][0]." ".$rankDiff;

  
		return $_backlinks;
	}
	
	public static function getSaturation($SiteID='1', $time='',$table='google',$limit='2')
	{
		$db = JFactory::getDbo();


    if($time) $wheretime = "AND result_time <= ".$time; else $wheretime = "AND result_time < ".time();

		$db->setQuery(
			'SELECT '.$table.'' . 
      ' FROM #__seopanel_saturationresults WHERE website_id ='.$SiteID.
      ' '.$wheretime.'  ORDER BY result_time DESC' .
      ' LIMIT 0 , '.$limit 
     );

		$_saturation = $db->loadRowList();

   
		// Check for a database error.
		if ($db->getErrorNum()) {
			JError::raiseNotice(500, $db->getErrorMsg());
			return null;
		}

			  
          $rankDiff = '';
					$rankDiff = $_saturation[0][0] - $_saturation[1][0];
          
          
          if ($rankDiff !=0){
					if ($rankDiff > 0) {
						$rankDiff = "<font class='green'>(+$rankDiff)</font>";
					}elseif ($rankDiff < 0) {
						$rankDiff = "<font class='red'>($rankDiff)</font>";
					}
        } else {$rankDiff = '';}

        if ($limit!=2){
        $_saturation = $_saturation[0][0];
        } else {
        $_saturation = empty ($_saturation[0][0]) ? '0' : $_saturation[0][0]." ".$rankDiff;
        }
  
		return $_saturation;
	}	
	
	public static function getPagerank($SiteID='1', $time='',$table='google',$limit='2')
	{
		$db = JFactory::getDbo();


    if($time) $wheretime = "AND result_time <= ".$time; else $wheretime = "AND result_time < ".time();

		$db->setQuery(
			'SELECT '.$table.'' . 
      ' FROM #__seopanel_rankresults WHERE website_id ='.$SiteID.
      ' '.$wheretime.'  ORDER BY result_time DESC' .
      ' LIMIT 0 , '.$limit 
     );

		$_pagerank = $db->loadRowList();

   
		// Check for a database error.
		if ($db->getErrorNum()) {
			JError::raiseNotice(500, $db->getErrorMsg());
			return null;
		}

			  
          $rankDiff = '';
          if ($table == 'alexa_rank') 
          $rankDiff = $_pagerank[1][0] - $_pagerank[0][0];
					else $rankDiff = $_pagerank[0][0] - $_pagerank[1][0];
          
          
          if ($rankDiff !=0){
					if ($rankDiff > 0) {
						$rankDiff = "<font class='green'>(+$rankDiff)</font>";
					}elseif ($rankDiff < 0) {
						$rankDiff = "<font class='red'>($rankDiff)</font>";
					}
        } else {$rankDiff = '';}

        if ($limit!=2){
        $_pagerank = $_pagerank[0][0];
        } else { 
        $_pagerank = empty ($_pagerank[0][0]) ? '0' : $_pagerank[0][0]." ".$rankDiff;
        }
  
		return $_pagerank;
	}
	
	
	public static function printGooglePageRank($pageRank){

		if($pageRank >= 0){
			$imageUrl = 'components/com_seopanel/assets/images/pr/pr'.$pageRank.".gif";
		}else{
			$imageUrl = "components/com_seopanel/assets/images/pr/pr.gif";
		}

		echo "<img src='$imageUrl'>";
	}	
	
	
	
	public static function footer()
	{
		echo 'Copyright &copy; '.date ('Y',time()).' by <a target="_blank" href="http://www.seo-panel.de">Seo-Panel.de</a>. Alle Rechte vorbehalten. <br>SEO Panel Pro - Version 1.0.2';
	}
}
