<?php
/**
 * @version     1.0.1
 * @package     com_seopanel
 * @copyright   Copyright (C) 2011. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Created by Jennifer Grotheer - http://www.seo-panel.de
 */

defined('_JEXEC') or die;

jimport('joomla.application.component.model');

/**
 * Methods supporting a list of Seopanel records.
 */
class SeopanelModelPanel extends JModel
{

	/**
	 * Websites data in array
	 *
	 * @var array
	 */
	var $_websites = null;

	/**
	 * Keywords data in array
	 *
	 * @var array
	 */
	var $_kewords = null;

	/**
	 * Plugins data in array
	 *
	 * @var array
	 */
	var $_plugins = null;
	
	/**
	 * Constructor
	 *
	 * @since 0.9
	 */
	function __construct()
	{
		parent::__construct();
	}

	/**
	 * Method to get websites item data
	 *
	 * @access public
	 * @return array
	 */
	function getWebsitesdata()
	{
		$_websites = array();

		/*
		* Get nr of all published websites
		*/
		$query = 'SELECT count(*)'
					. ' FROM #__seopanel_websites'
					. ' WHERE state = 1'
					;

		$this->_db->SetQuery($query);
  		$_websites[] = $this->_db->loadResult();

		/*
		* Get nr of all unpublished websites
		*/
		$query = 'SELECT count(*)'
					. ' FROM #__seopanel_websites'
					. ' WHERE state = 0'
					;

		$this->_db->SetQuery($query);
  		$_websites[] = $this->_db->loadResult();

		/*
		* Get nr of all archived websites
		*/
		$query = 'SELECT count(*)'
					. ' FROM #__seopanel_websites'
					. ' WHERE state = 2'
					;

		$this->_db->SetQuery($query);
  		$_websites[] = $this->_db->loadResult();

  		/*
		* Get total nr of websites
		*/
		$_websites[] = array_sum($_websites);

		return $_websites;
	}

	/**
	 * Method to get keywords item data
	 *
	 * @access public
	 * @return array
	 */
	function getKewordsdata()
	{
		$_keywords = array();

		/*
		* Get nr of all published keywords
		*/
		$query = 'SELECT count(*)'
					. ' FROM #__seopanel_keywords'
					. ' WHERE state = 1'
					;

		$this->_db->SetQuery($query);
  		$_keywords[] = $this->_db->loadResult();

		/*
		* Get nr of all unpublished keywords
		*/
		$query = 'SELECT count(*)'
					. ' FROM #__seopanel_keywords'
					. ' WHERE state = 0'
					;

		$this->_db->SetQuery($query);
  		$_keywords[] = $this->_db->loadResult();

		/*
		* Get nr of all archived keywords
		*/
		$query = 'SELECT count(*)'
					. ' FROM #__seopanel_keywords'
					. ' WHERE state = 2'
					;

		$this->_db->SetQuery($query);
  		$_keywords[] = $this->_db->loadResult();
  		/*
		* Get total nr of keywords
		*/
  		$_keywords[] = array_sum($_keywords);

		return $_keywords;
	}

	/**
	 * Method to get plugins for seopanel
	 *
	 * @access public
	 * @return array
	 */
	function getPluginsdata()
	{
		$_plugins = array();

		/*
		* Get plugins where published
		*/
		$query = 'SELECT *'
					. ' FROM #__extensions'
					. ' WHERE enabled=1 AND folder="seopanel"' // 
					;
 
 		$this->_db->SetQuery($query);
  		$_plugins[] = $this->_db->loadRowList();


		return $_plugins;
	}
	
	
}
