<?php
/**
 * @version     1.0.1
 * @package     com_seopanel
 * @copyright   Copyright (C) 2011. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Created by Jennifer Grotheer - http://www.seo-panel.de
 */

// No direct access
defined('_JEXEC') or die;

jimport('joomla.application.component.view');


/**
 * View class for a list of Seopanel.
 */
class SeopanelViewPanel extends JView
{
	protected $items;
	protected $pagination;
	protected $state;

	/**
	 * Display the view
	 */
	public function display($tpl = null)
	{
	
	
		//Load pane behavior	
	  jimport('joomla.html.pane');		
    $this->pane   	= & JPane::getInstance('sliders');
	  
	  
		$this->state		= $this->get('State');
		$this->items		= $this->get('Items');
		$this->pagination	= $this->get('Pagination');

		// Get data from the model
		$websites      = $this->get( 'Websitesdata');
		$keywords       = $this->get( 'Kewordsdata');

		$this->assignRef('websites'		, $websites);
		$this->assignRef('keywords'		, $keywords);

	
		// Get plugins from the model
		$plugins      = $this->get( 'Pluginsdata');    
		$this->assignRef('Plugins'	, $plugins);
		
		
		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}		
		
		$this->addToolbar();		
    parent::display($tpl);
	}

	/**
	 * Add the page title and toolbar.
	 *
	 * @since	1.6
	 */
	protected function addToolbar()
	{
		require_once JPATH_COMPONENT.DS.'helpers'.DS.'seopanel.php';

		$state	= $this->get('State');
		$canDo	= SeopanelHelper::getActions($state->get('filter.category_id'));

		JToolBarHelper::title(JText::_('COM_SEOPANEL'), 'panel.png' );

    JToolBarHelper::Help('help','JTOOLBAR_HELP');

		if ($canDo->get('core.admin')) {
			JToolBarHelper::preferences('com_seopanel');
		}


	}
	
		function quickiconButton( $link, $image, $text, $modal = 0 )
	{
		//initialise variables
		$lang 		= & JFactory::getLanguage();
  		?>

		<div style="float:<?php echo ($lang->isRTL()) ? 'right' : 'left'; ?>;">
			<div class="icon">
				<?php
				if ($modal == 1) {
					JHTML::_('behavior.modal');
				?>
					<a href="<?php echo $link.'&amp;tmpl=component'; ?>" style="cursor:pointer" class="modal" rel="{handler: 'iframe', size: {x: 650, y: 400}}">
				<?php
				} else {
				?>
					<a href="<?php echo $link; ?>">
				<?php
				}

					echo JHTML::_('image', 'administrator/components/com_seopanel/assets/images/'.$image, $text );
				?>
					<span><?php echo $text; ?></span>
				</a>
			</div>
		</div>
		<?php
	}
	
			function quickiconButtonPlugin( $link, $image, $text, $plugin, $modal = 0 )
	{
	
  	//initialise variables
		  $lang 		= & JFactory::getLanguage();

      $extension = 'plg_seopanel_'.$plugin;
      $base_dir = JPATH_ADMINISTRATOR;

      $lang->load($extension, $base_dir, null, true);
  		?>

		<div style="float:<?php echo ($lang->isRTL()) ? 'right' : 'left'; ?>;">
			<div class="icon">
				<?php
				if ($modal == 1) {
					JHTML::_('behavior.modal');
				?>
					<a href="<?php echo $link.'&amp;tmpl=component'; ?>" style="cursor:pointer" class="modal" rel="{handler: 'iframe', size: {x: 750, y: 500}}">
				<?php
				} else {
				?>
					<a href="<?php echo $link; ?>">
				<?php
				}

					echo JHTML::_('image', 'plugins/seopanel/'.$plugin.'/images/'.$image, $text );
				?>
					<span><?php echo  JText::_( $text ); ?></span>
				</a>
			</div>
		</div>
		<?php
	}
	
}
