<?php

/**
 * @version     1.0.2 Pro
 * @package     com_seopanel
 * @copyright   Copyright (C) 2011. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Created by Jennifer Grotheer - http://www.seo-panel.de
 */
defined('_JEXEC') or die('Restricted access');

# class defines all report controller functions
class ReportController extends SeoCron {
	var $seLIst;
	var $showAll = false;

  function _params($get) {
  
    $params =&JComponentHelper::getParams('com_seopanel');

    return $params->get($get);
  }
	
	# function to format pagecontent
	function formatPageContent($seInfoId, $pageContent) {

		    if (!empty($this->seList[$seInfoId]['from_pattern']) && $this->seList[$seInfoId]['to_pattern']) {
	        $pattern = $this->seList[$seInfoId]['from_pattern']."(.*)".$this->seList[$seInfoId]['to_pattern'];
	        if (preg_match("/$pattern/is", $pageContent, $matches)) {
	            if (!empty($matches[1])) {
	                $pageContent = $matches[1];
	            }
	        }
	    }
	    return $pageContent;	    
	}
	
	# func to crawl keyword
	function crawlKeyword( $keywordInfo, $seId='' ) {

    $this->spider = New Spider();

    $crawlResult = array();
		$websiteUrl = $this->formatUrl($keywordInfo['url']);
		
		if(empty($websiteUrl)) return $crawlResult;
		if(empty($keywordInfo['name'])) return $crawlResult;	
		
		$seList = explode(':', $keywordInfo['searchengines']);

		foreach($seList as $seInfoId){
			if(!empty($seId) && ($seInfoId != $seId)) continue;
			$this->seFound = 1;
			$searchUrl = str_replace('[--keyword--]', urlencode(stripslashes($keywordInfo['name'])), $this->seList[$seInfoId]['url']);
			$searchUrl = str_replace('[--lang--]', $keywordInfo['lang_code'], $searchUrl);
			$searchUrl = str_replace('[--country--]', $keywordInfo['country_code'], $searchUrl);
			$seUrl = str_replace('[--start--]', $this->seList[$seInfoId]['start'], $searchUrl);

			if(!empty($this->seList[$seInfoId]['cookie_send'])){
				$this->seList[$seInfoId]['cookie_send'] = str_replace('[--lang--]', $keywordInfo['lang_code'], $this->seList[$seInfoId]['cookie_send']);
				$this->spider->_CURLOPT_COOKIE = $this->seList[$seInfoId]['cookie_send'];				
			}

			$result = $this->spider->getContent($seUrl);

			$pageContent = $this->formatPageContent($seInfoId, $result['page']);
			$seStart = $this->seList[$seInfoId]['start'] + $this->seList[$seInfoId]['start_offset'];
			while(empty($result['error']) && ($seStart < $this->seList[$seInfoId]['max_results']) ){
				$seUrl = str_replace('[--start--]', $seStart, $searchUrl);
				$result = $this->spider->getContent($seUrl);
				$pageContent .= $this->formatPageContent($seInfoId, $result['page']);
				$seStart += $this->seList[$seInfoId]['start_offset'];
				sleep($this->_params('delay'));
			}

			# to check whether utf8 conversion needed
			if(!empty($this->seList[$seInfoId]['encoding'])){
				$pageContent = mb_convert_encoding($pageContent, "UTF-8", $this->seList[$seInfoId]['encoding']);
			}

			$crawlStatus = 0;
			if(empty($result['error'])){	
        
 	
				if(preg_match_all($this->seList[$seInfoId]['regex'], $pageContent, $matches)){
					$urlList = $matches[$this->seList[$seInfoId]['url_index']];
					$crawlResult[$seInfoId]['matched'] = array();
        
          foreach($urlList as $i => $url){
						$url = strip_tags($url);
						$url = str_replace(array('http%3a', 'https%3a'), array('http:', 'https:'), $url);
						if(!preg_match('/^http:\/\/|^https:\/\//i', $url)) continue;
						if($this->showAll || stristr($url, $websiteUrl)){

							if($this->showAll && stristr($url, $websiteUrl)){
								$matchInfo['found'] = 1; 
							}else{
								$matchInfo['found'] = 0;
							}

							$matchInfo['url'] = $url;
							$matchInfo['title'] = strip_tags($matches[$this->seList[$seInfoId]['title_index']][$i]);
							$matchInfo['description'] = strip_tags($matches[$this->seList[$seInfoId]['description_index']][$i]);
							$matchInfo['rank'] = $i + 1;
							$crawlResult[$seInfoId]['matched'][] = $matchInfo;
						}							
					}
					$crawlStatus = 1;
				}else{
					if($this->_params('debug')){
						echo "<p class='note' style='text-align:left;'>Error occured while parsing ".$seUrl. " Regex not matched <br>\n</p>";
					}
				}	
			}else{
				if($this->_params('debug')){
					echo "<p class='note' style='text-align:left;'>Error occured while crawling ".$seUrl ." ".$result['errmsg']."<br>\n</p>";
				}
			}			
			$crawlResult[$seInfoId]['status'] = $crawlStatus;			
			sleep($this->_params('delay'));
		}
		return  $crawlResult;
	}
	

}
?>