<?php
/**
 * @version     1.0.2 Pro
 * @package     com_seopanel
 * @copyright   Copyright (C) 2011. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Created by Jennifer Grotheer - http://www.seo-panel.de
 */
 
defined('_JEXEC') or die('Restricted access');

class SeoCron { 

var $debug = true;
var $url;
var $colList = array('google' => 'google', 'yahoo' => 'yahoo', 'msn' => 'msn');
var $colBacklinks = array( 'google' => 'google', 'yahoo' => 'yahoo', 'msn' => 'msn' , 'altavista' => 'altavista',  'alltheweb' => 'alltheweb' );
  function _params($get) {
  
    $params =&JComponentHelper::getParams('com_seopanel');

    return $params->get($get);
  }


	function run() {

	  $db   =  JFactory::getDbo(); 
    include 'spider.php';
    $this->spider = New Spider(); 

		$db->setQuery(
			'SELECT id, domain AS url' .
			' FROM #__seopanel_websites WHERE state=1'
		  );
      
      $websites = $db->loadAssocList();
      
      foreach ($websites as $key=>$website) {
        if ($this->_params('visibility'))   $this->saturationCheckerCron( $website[url],$website[id]); 
        if ($this->_params('rank'))         $this->PagerankCheckerCron ($website[url],$website[id]); 
        if ($this->_params('backlinks'))    $this->backlinkCheckerCron ($website[url],$website[id]);              	
        if ($this->_params('keywords'))     $this->keywordPositionCheckerCron($website[id]);
   
      }
}

############################ keywordPositionCheckerCron ########################################################


	# function to format pagecontent
	function formatPageContent($seInfoId, $pageContent) {
	    if (!empty($this->seList[$seInfoId]['from_pattern']) && $this->seList[$seInfoId]['to_pattern']) {
	        $pattern = $this->seList[$seInfoId]['from_pattern']."(.*)".$this->seList[$seInfoId]['to_pattern'];
	        if (preg_match("/$pattern/is", $pageContent, $matches)) {
	            if (!empty($matches[1])) {
	                $pageContent = $matches[1];
	            }
	        }
	    }
	    return $pageContent;	    
	}
	
	
	# func to get all search engines
	function __getAllCrawlFormatedSearchEngines(){
	  $db   =  JFactory::getDbo(); 
		$db->setQuery('select * from #__seopanel_searchengines where status=1');
		$list = $db->loadAssocList();
		$seList = array();
		foreach($list as $seInfo){
			$seId = $seInfo['id'];
			$seInfo['regex'] = "/".$seInfo['regex']."/is";
			$search = array('[--num--]');
			$replace = array($seInfo['no_of_results_page']);
			$seInfo['url'] = str_replace($search, $replace, $seInfo['url']);
			$seList[$seId] = $seInfo;
		}	
		return $seList;
	}

	# func to crawl keyword
	function keywordPositionCheckerCron($websiteId){
		
		include_once("keywords.php");
		
		$reportController = New ReportController();

		$reportController->seList = $this->__getAllCrawlFormatedSearchEngines();
		
    $db   =  JFactory::getDbo(); 
		$db->setQuery('select k.*,w.domain AS url from #__seopanel_keywords k,#__seopanel_websites w where k.website_id=w.id and w.id='.$websiteId.' and k.state=1 order by k.name');
		$keywordList = $db->loadAssocList();		

		$this->debugMsg("Starting keyword position checker cron for website: <b>{$keywordList[0][url]}</b>....<br>\n");

		# loop through each keyword			
		foreach ( $keywordList as $keywordInfo ) {
			$reportController->seFound = 0;
			$crawlResult = $reportController->crawlKeyword($keywordInfo);

			foreach($crawlResult as $sengineId => $matchList){
				if($matchList['status']){
					foreach($matchList['matched'] as $i => $matchInfo){
						$remove = ($i == 0) ? true : false;						
						$matchInfo['se_id'] = $sengineId;						
						$matchInfo['keyword_id'] = $keywordInfo['id'];
						
						$this->saveKeywordResults($matchInfo, $remove);
					}
					$this->debugMsg("Successfully crawled keyword <b>{$keywordInfo['name']}</b> results from ".$reportController->seList[$sengineId]['domain'].".....<br>\n");
				}else{
					$this->debugMsg("Crawling keyword </b>{$keywordInfo['name']}</b> results from ".$reportController->seList[$sengineId]['domain']." failed......<br>\n");
				}
			}
			if(empty($reportController->seFound)){
				$this->debugMsg("Keyword <b>{$keywordInfo['name']}</b> not assigned to required search engines........\n");
			}
			sleep($this->_params('delay'));
		}
	}


############################ saturationCheckerCron ########################################################


function formatUrl( $url ) {
	$url = str_replace('http://', '', $url);
	$url = str_replace('https://', '', $url);
	$url = str_replace('www.', '', $url);
	return $url;
}
 
    
    
function addHttpToUrl($url){
	if(!stristr($url, 'http://') && !stristr($url, 'https://')){
		$url = 'http://'.$url;
	}
	$url = strtolower($url);
	return $url;
}
 
 
	function saturationCheckerCron($websiteUrl,$websiteId){
		
		$this->debugMsg("Starting Search engine saturation Checker cron for website: <b>$websiteUrl</b>....<br>\n");
    
    $websiteInfo['id'] = $websiteId;
		$websiteInfo['url'] = $this->addHttpToUrl($websiteUrl);			
		foreach ($this->colList as $col => $dbCol) {
			$websiteInfo[$col] = $this->__getSaturationRank($col, $websiteInfo['url']);
		}
			
		$this->saveRankResults($websiteInfo, true);			

    $this->debugMsg("Saved Search Engine Saturation results of <b>$websiteUrl</b>.....</br>\n");
		
	}

	function __getSaturationRank ($engine, $url) {

		$this->url = $this->addHttpToUrl($url);
		
		switch ($engine) {
		
			#google
			case 'google':
				$url = 'http://www.google.com/search?q=site%3A' . urlencode($this->url);			
		    $v['page'] = $this->getUrl($url);
				$v = empty($v['page']) ? '' :  $v['page'];				
				
				if(preg_match('/about ([0-9\,]+) results/si', $v, $r)){					
				}elseif(preg_match('/<div id=resultStats>([0-9\,]+) results/si', $v, $r)){					
				}elseif(preg_match('/([0-9\,]+) results/si', $v, $r)){					
				}elseif(preg_match('/about <b>([0-9\,]+)<\/b> from/si', $v, $r)){					
				}
								
				$rank = ($r[1]) ? str_replace(',', '', $r[1]) : 0;
				if(empty($rank)){
					preg_match('/of <b>([0-9\,]+)<\/b>/si', $v, $r);
					$rank = ($r[1]) ? str_replace(',', '', $r[1]) : 0;
				}
				return $rank;
				break;
				
			#yahoo
			case 'yahoo':
				$url = 'http://siteexplorer.search.yahoo.com/advsearch?p=' . urlencode($this->url);
		    $v['page'] = $this->getUrl($url);
				$v = empty($v['page']) ? '' :  $v['page'];
				preg_match('/Pages \(([0-9\,]+)\)/si', $v, $r);
				return ($r[1]) ? str_replace(',', '', $r[1]) : 0;
				break;
				
			#msn
			case 'msn':
				$url = 'http://www.bing.com/search?q=site%3A' . urlencode($this->url);
		    $v['page'] = $this->getUrl($url);
				$v = empty($v['page']) ? '' :  $v['page'];				
				preg_match('/of ([0-9\,]+) results/si', $v, $r);
				return ($r[1]) ? str_replace(',', '', $r[1]) : 0;
				break;
		}
		
		return 0;
	}

############################ GooglePageRank AND AlexaPageRank ########################################################


	function PagerankCheckerCron($websiteUrl, $websiteId){
		
		$this->debugMsg("Starting Rank Checker cron for website: <b>$websiteUrl</b>....<br>\n");
		
    $websiteInfo['id'] = $websiteId;
		$websiteInfo['url'] = $this->addHttpToUrl($websiteUrl);	
		$websiteInfo['googlePagerank'] = $this->__getGooglePageRank($websiteUrl);
		$websiteInfo['alexaRank'] = $this->__getAlexaRank($websiteUrl);
			
		$this->savePageRankResults($websiteInfo, true);			
		$this->debugMsg("Saved rank results of <b>$websiteUrl</b>.....<br>\n");
		
	}


	function checkHash($Hashnum) {
		$CheckByte = 0;
		$Flag = 0;

		$HashStr = sprintf('%u', $Hashnum) ;
		$length = strlen($HashStr);

		for ($i = $length - 1; $i >= 0; $i --) {
			$Re = $HashStr{$i};
			if (1 === ($Flag % 2)) {
				$Re += $Re;
				$Re = (int)($Re / 10) + ($Re % 10);
			}
			$CheckByte += $Re;
			$Flag ++;
		}

		$CheckByte %= 10;
		if (0!== $CheckByte) {
			$CheckByte = 10 - $CheckByte;
			if (1 === ($Flag % 2) ) {
				if (1 === ($CheckByte % 2)) {$CheckByte += 9;}
				$CheckByte >>= 1;
			}
		}

		return '7'.$CheckByte.$HashStr;
	}

	function strToNum($Str, $Check, $Magic) {
		$Int32Unit = 4294967296;
		$length = strlen($Str);
		for ($i = 0; $i < $length; $i++) {
			$Check *= $Magic;
			if ($Check >= $Int32Unit) {
				$Check = ($Check - $Int32Unit * (int) ($Check / $Int32Unit));
				$Check = ($Check < -2147483648)? ($Check + $Int32Unit) : $Check;
			}
			$Check += ord($Str{$i});
		}
		return $Check;
	}


	function hashURL($String) {
		$Check1 = $this->strToNum($String, 0x1505, 0x21);
		$Check2 = $this->strToNum($String, 0, 0x1003F);

		$Check1 >>= 2;
		$Check1 = (($Check1 >> 4) & 0x3FFFFC0 ) | ($Check1 & 0x3F);
		$Check1 = (($Check1 >> 4) & 0x3FFC00 ) | ($Check1 & 0x3FF);
		$Check1 = (($Check1 >> 4) & 0x3C000 ) | ($Check1 & 0x3FFF);

		$T1 = (((($Check1 & 0x3C0) << 4) | ($Check1 & 0x3C)) <<2 ) | ($Check2 & 0xF0F );
		$T2 = (((($Check1 & 0xFFFFC000) << 4) | ($Check1 & 0x3C00)) << 0xA) | ($Check2 & 0xF0F0000 );

		return ($T1 | $T2);
	}



	# google_rank

	function __getGooglePageRank ($url) {

    $url = "http://toolbarqueries.google.com/tbr?client=navclient-auto&ch=".$this->CheckHash($this->hashURL($url))."&features=Rank&q=info:".$url."&num=100&filter=0";
		$ret['page'] = $this->getUrl($url);
		if(!empty($ret['page'])){
			preg_match('/Rank_([0-9]+):([0-9]+):([0-9]+)/si', $ret['page'], $matches);
			return ($matches[3]) ? $matches[3] : 0;
		}
		return 0;
	}

	# alexa_rank
	function __getAlexaRank ($url) {
		$url = 'http://data.alexa.com/data?cli=10&dat=snbamz&url=' . urlencode($url);
		$ret['page'] = $this->getUrl($url);
		if(!empty($ret['page'])){
			preg_match('/\<popularity url\="(.*?)" TEXT\="([0-9]+)"\/\>/si', $ret['page'], $matches);
			return ($matches[2]) ? $matches[2] : 0;
		}
		return 0;
	}


############################ backlinkCheckerCron ########################################################

	# func to generate backlink reports from cron
	function backlinkCheckerCron($websiteUrl, $websiteId){

		$this->debugMsg("Starting Backlink Checker cron for website: <b>$websiteUrl</b>....<br>\n");
		
    $websiteInfo['id'] = $websiteId;
		$websiteInfo['url'] = $this->addHttpToUrl($websiteUrl);				
		foreach ($this->colBacklinks as $col => $dbCol) {
			$websiteInfo[$col] = $this->__getBacklinks($col, $websiteInfo['url']);
		}
		
		$this->saveBacklinkResults($websiteInfo, true);			
		$this->debugMsg("Saved backlink results of <b>$websiteUrl</b>.....</br>\n");
		
	}
	
	
		function __getBacklinks ($engine, $url) {
		
		switch ($engine) {
			
			#google
			case 'google':
				$url = 'http://www.google.com/search?q=link%3A' . urlencode($url);			
				$v['page'] = $this->getUrl($url);
				$v = empty($v['page']) ? '' :  $v['page'];
				if(preg_match('/about ([0-9\,]+) results/si', $v, $r)){					
				}elseif(preg_match('/<div id=resultStats>([0-9\,]+) results/si', $v, $r)){					
				}elseif(preg_match('/([0-9\,]+) results/si', $v, $r)){					
				}elseif(preg_match('/about <b>([0-9\,]+)<\/b> linking/si', $v, $r)){					
				}
				return ($r[1]) ? str_replace(',', '', $r[1]) : 0;
				break;
				
			#yahoo
			case 'yahoo':
				$url = "http://siteexplorer.search.yahoo.com/advsearch?p=".urlencode($url)."&bwm=i&bwmo=d&bwmf=s";
				$v['page'] = $this->getUrl($url);
				$v = empty($v['page']) ? '' :  $v['page'];
				preg_match('/Inlinks \((.+?)\)/si', $v, $r);
				return ($r[1]) ? str_replace(',', '', $r[1]) : 0;
				break;
				
			#msn
			case 'msn':
				$url = 'http://www.bing.com/search?q=link%3A' . urlencode($url);
				$v['page'] = $this->getUrl($url);
        $v = empty($v['page']) ? '' :  $v['page'];				
				preg_match('/of ([0-9\,]+) results/si', $v, $r);
				return ($r[1]) ? str_replace(',', '', $r[1]) : 0;
				break;
				
			#altavista
			case 'altavista':
				$url = "http://siteexplorer.search.yahoo.com/advsearch?p=".urlencode($url)."&bwm=i&bwmf=u&bwms=p&fr=altavista";
        				$v['page'] = $this->getUrl($url);

                $v = empty($v['page']) ? '' :  $v['page'];
                preg_match('/Inlinks \((.+?)\)/si', $v, $r);
                return ($r[1]) ? str_replace(',', '', $r[1]) : 0;
                break;
				
			#alltheweb
			case 'alltheweb':				
				$url = "http://siteexplorer.search.yahoo.com/advsearch?p=".urlencode($url)."&bwm=i&bwmf=u&bwms=p&fr=alltheweb";
        				$v['page'] = $this->getUrl($url);
                $v = empty($v['page']) ? '' :  $v['page'];
                preg_match('/Inlinks \((.+?)\)/si', $v, $r);
                return ($r[1]) ? str_replace(',', '', $r[1]) : 0;
                break;
		}
		
		return 0;
	}

########################## SAVE INTO DB ###################################################################

	# function to save rank details
	function saveRankResults($matchInfo, $remove=false) {
		$time = mktime(0, 0, 0, date('m'), date('d'), date('Y'));

		$db   =  JFactory::getDbo(); 
		
		if($remove){				
			$sql = "delete from #__seopanel_saturationresults where website_id={$matchInfo['id']} and result_time=$time";
     		$db->setQuery($sql);
     		$db->query();

	}
		
		$sql = "insert into #__seopanel_saturationresults(website_id,google,yahoo,msn,result_time)
				values({$matchInfo['id']},{$matchInfo['google']},{$matchInfo['yahoo']},{$matchInfo['msn']},$time)";
     		$db->setQuery($sql);
     		$db->query();
	}


	# function to save pagerank details
	function savePageRankResults($matchInfo, $remove=false) {
		$time = mktime(0, 0, 0, date('m'), date('d'), date('Y'));

		$db   =  JFactory::getDbo(); 
		
		if($remove){				
			$sql = "delete from #__seopanel_rankresults where website_id={$matchInfo['id']} and result_time=$time";
     		$db->setQuery($sql);
     		$db->query();
		}
		
		$sql = "insert into #__seopanel_rankresults(website_id,google_pagerank,alexa_rank,result_time)
				values({$matchInfo['id']},{$matchInfo['googlePagerank']},{$matchInfo['alexaRank']},$time)";
     		$db->setQuery($sql);
     		$db->query();
	}


	# function to save backlink details
	function saveBacklinkResults($matchInfo, $remove=false) {
		$time = mktime(0, 0, 0, date('m'), date('d'), date('Y'));

		$db   =  JFactory::getDbo(); 
		
		if($remove){				
			$sql = "delete from #__seopanel_backlinkresults where website_id={$matchInfo['id']} and result_time=$time";
     		$db->setQuery($sql);
     		$db->query();
		}
		
		$sql = "insert into #__seopanel_backlinkresults(website_id,google,yahoo,msn,altavista,alltheweb,result_time)
				values({$matchInfo['id']},{$matchInfo['google']},{$matchInfo['yahoo']},{$matchInfo['msn']},{$matchInfo['altavista']},{$matchInfo['alltheweb']},$time)";
     		$db->setQuery($sql);
     		$db->query();
	}


	# func to save the keyword
	function saveKeywordResults($matchInfo, $remove=false) {
		$time = mktime(0, 0, 0, date('m'), date('d'), date('Y'));

		$db   =  JFactory::getDbo(); 

		if($remove){
		$sql = "select id from #__seopanel_searchresults where keyword_id={$matchInfo['keyword_id']} and searchengine_id={$matchInfo['se_id']} and time=$time";
        $db->setQuery($sql);
  	    $recordList = $db->loadAssocList();
			
			if(count($recordList) > 0){
				foreach($recordList as $recordInfo){
		$sql = "delete from #__seopanel_searchresultdetails where searchresult_id=".$recordInfo['id'];
     		$db->setQuery($sql);
     		$db->query();
				}
				
		$sql = "delete from #__seopanel_searchresults where keyword_id={$matchInfo['keyword_id']} and searchengine_id={$matchInfo['se_id']} and time=$time";
     		$db->setQuery($sql);
     		$db->query();
     		
			}
		}
		
		$sql = "insert into #__seopanel_searchresults(keyword_id,searchengine_id,rank,time)
				values({$matchInfo['keyword_id']},{$matchInfo['se_id']},{$matchInfo['rank']},$time)";
     		$db->setQuery($sql);
     		$db->query();
		    $recordId = $db->insertid();				
	
		$sql = "insert into #__seopanel_searchresultdetails(searchresult_id,url,title,description)
				values($recordId,'{$matchInfo['url']}','".addslashes($matchInfo['title'])."','".addslashes($matchInfo['description'])."')";
        $db->setQuery($sql);
     		$db->query();
	}

	# func to show debug messages
	function debugMsg($msg=''){
		
		if($this->debug == true) print $msg;
	}

	# func to get URL 
  function getUrl($url)
  {
  	$handle = fopen($url, "r");
  	if($handle)
  	{
  		$contents = '';
  		while (!feof($handle)) {$contents .= fread($handle, 8192);}
  		return $contents;
  	}
  	else return false;
  	
  }
}